<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="800px">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="80px"
    >
      <el-form-item v-if="formData.parentSource" label="上级来源">
        <el-input v-model="formData.parentSource" disabled />
      </el-form-item>
      <el-form-item label="来源名称" prop="sourceName">
        <el-input v-model="formData.sourceName" placeholder="请输入来源名称" />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入排序" type="number" :min="0" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio :label="0"> 启用 </el-radio>
          <el-radio :label="1"> 禁用 </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input
          type="textarea"
          v-model="formData.remark"
          placeholder="请输入备注"
          :autosize="{ minRows: 4, maxRows: 8 }"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="DialogSource" setup>
import * as SourceApi from '@/api/clue/source'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  sourceName: '',
  sort: 1,
  remark: ''
})
const formRules = reactive({
  sourceName: [{ required: true, message: '名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type, info) => {
  dialogVisible.value = true
  dialogTitle.value = type == 'update' ? '修改来源' : '新增来源'
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (info?.sourceId) {
    formLoading.value = true
    try {
      if (type == 'update') {
        formData.value = await SourceApi.getSource(info.sourceId)
      } else {
        formData.value.parentSource = info.sourceName
        formData.value.parentId = info.sourceId
      }
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    if (formType.value === 'update') {
      await SourceApi.updateSource(formData.value)
      message.success(t('common.updateSuccess'))
    } else {
      await SourceApi.createSource(formData.value)
      message.success(t('common.createSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    sourceName: '',
    status: 0,
    sort: 1,
    remark: ''
  }
  formRef.value?.resetFields()
}
</script>
